(define (domain woodworking)
 (:requirements :typing :fluents)
 (:types acolour - object awood - object woodobj - object machine - object surface - object treatmentstatus - object highspeed-saw - machine glazer - machine grinder - machine immersion-varnisher - machine planer - machine saw - machine spray-varnisher - machine board - woodobj part - woodobj)
 (:predicates (idle ?machine - machine) (unused ?obj - part) (available ?obj - woodobj) (surface-condition ?obj - woodobj ?surface - surface) (treatment ?obj - part ?treatment - treatmentstatus) (colour ?obj - part ?colour - acolour) (wood ?obj - woodobj ?wood - awood) (in-highspeed-saw ?b - board ?m - highspeed-saw) (empty ?m - highspeed-saw) (has-colour ?machine - machine ?colour - acolour) (grind-treatment-change ?old - treatmentstatus ?new - treatmentstatus) (is-smooth ?surface - surface))
 (:constants verysmooth - surface smooth - surface rough - surface varnished - treatmentstatus glazed - treatmentstatus untreated - treatmentstatus colourfragments - treatmentstatus natural - acolour)
 (:functions
  (board-size ?board - board) 
  (goal-size ?obj - part))
 (:action do-immersion-varnish
  :parameters ( ?x - part ?m - immersion-varnisher ?newcolour - acolour ?surface - surface)
  :precondition (and (idle ?m) (available ?x) (surface-condition ?x ?surface) (is-smooth ?surface) (has-colour ?m ?newcolour) (treatment ?x untreated))
  :effect (and (available ?x) (treatment ?x varnished) (colour ?x ?newcolour) (not (available ?x)) (not (treatment ?x untreated)) (not (colour ?x natural)))
 )
 (:action do-spray-varnish
  :parameters ( ?x - part ?m - spray-varnisher ?newcolour - acolour ?surface - surface)
  :precondition (and (idle ?m) (available ?x) (surface-condition ?x ?surface) (is-smooth ?surface) (has-colour ?m ?newcolour) (treatment ?x untreated))
  :effect (and (available ?x) (treatment ?x varnished) (colour ?x ?newcolour) (not (available ?x)) (not (treatment ?x untreated)) (not (colour ?x natural)))
 )
 (:action do-glaze
  :parameters ( ?x - part ?m - glazer ?newcolour - acolour)
  :precondition (and (idle ?m) (available ?x) (has-colour ?m ?newcolour) (treatment ?x untreated))
  :effect (and (available ?x) (treatment ?x glazed) (colour ?x ?newcolour) (not (available ?x)) (not (treatment ?x untreated)) (not (colour ?x natural)))
 )
 (:action do-grind
  :parameters ( ?x - part ?m - grinder ?oldsurface - surface ?oldcolour - acolour ?oldtreatment - treatmentstatus ?newtreatment - treatmentstatus)
  :precondition (and (idle ?m) (available ?x) (surface-condition ?x ?oldsurface) (is-smooth ?oldsurface) (colour ?x ?oldcolour) (treatment ?x ?oldtreatment) (grind-treatment-change ?oldtreatment ?newtreatment))
  :effect (and (available ?x) (surface-condition ?x verysmooth) (treatment ?x ?newtreatment) (colour ?x natural) (not (available ?x)) (not (surface-condition ?x ?oldsurface)) (not (treatment ?x ?oldtreatment)) (not (colour ?x ?oldcolour)))
 )
 (:action do-plane
  :parameters ( ?x - part ?m - planer ?oldsurface - surface ?oldcolour - acolour ?oldtreatment - treatmentstatus)
  :precondition (and (idle ?m) (available ?x) (surface-condition ?x ?oldsurface) (treatment ?x ?oldtreatment) (colour ?x ?oldcolour))
  :effect (and (available ?x) (surface-condition ?x smooth) (treatment ?x untreated) (colour ?x natural) (not (available ?x)) (not (surface-condition ?x ?oldsurface)) (not (treatment ?x ?oldtreatment)) (not (colour ?x ?oldcolour)))
 )
 (:action load-highspeed-saw
  :parameters ( ?b - board ?m - highspeed-saw)
  :precondition (and (idle ?m) (empty ?m) (available ?b))
  :effect (and (in-highspeed-saw ?b ?m) (not (available ?b)) (not (empty ?m)))
 )
 (:action unload-highspeed-saw
  :parameters ( ?b - board ?m - highspeed-saw)
  :precondition (and (idle ?m) (in-highspeed-saw ?b ?m))
  :effect (and (available ?b) (empty ?m) (not (in-highspeed-saw ?b ?m)))
 )
 (:action cut-board
  :parameters ( ?b - board ?p - part ?m - highspeed-saw ?w - awood ?surface - surface)
  :precondition (and (idle ?m) (unused ?p) (in-highspeed-saw ?b ?m) (wood ?b ?w) (surface-condition ?b ?surface) (>= (board-size ?b) (goal-size ?p)))
  :effect (and (available ?p) (wood ?p ?w) (surface-condition ?p ?surface) (colour ?p natural) (treatment ?p untreated) (not (unused ?p)) (decrease (board-size ?b) (goal-size ?p)))
 )
 (:action do-saw
  :parameters ( ?b - board ?p - part ?m - saw ?w - awood ?surface - surface)
  :precondition (and (idle ?m) (unused ?p) (available ?b) (wood ?b ?w) (surface-condition ?b ?surface) (>= (board-size ?b) (goal-size ?p)))
  :effect (and (available ?p) (wood ?p ?w) (surface-condition ?p ?surface) (colour ?p natural) (treatment ?p untreated) (not (unused ?p)) (decrease (board-size ?b) (goal-size ?p)))
 )
)
